package com.auth.common.model.valid.custom.enums;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

@Documented
@Constraint(validatedBy = {EnumValueValidator.class})
@Target({METHOD, FIELD, ANNOTATION_TYPE, CONSTRUCTOR, PARAMETER, TYPE_USE})
@Retention(RUNTIME)
public @interface EnumerateValid {

    String message() default "{com.auth.common.model.valid.custom.enums.Enumerate}";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};

    /**
     * 目标枚举类
     */
    Class<? extends Enum<?>> enumClass();

    /**
     * 是否忽略大小写
     */
    boolean ignoreCase() default false;

    /**
     * 是否允许为空
     */
    boolean allowNull() default true;

}
